#include "mainwidget.h"
#include "ui_mainwidget.h"
#include "qlistmodel.h"
#include "qsliderdeligate.h"

MainWidget::MainWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MainWidget)
{
    ui->setupUi(this);

    //Создает объект пользовательской модели
    QListModel* model = new QListModel(this);
    //Назначает списочному представлению модель
    ui->listView->setModel(model);
    //Создает объект пользовательского делегата
    QSliderDeligate* deligate = new QSliderDeligate(this);
    //Назначает табличному представлению модель
    ui->tableView->setModel(model);
    //Назначает списочному представлению делегата
    ui->listView->setItemDelegate(deligate);
}

MainWidget::~MainWidget()
{
    delete ui;
}
