#ifndef QLISTMODEL_H
#define QLISTMODEL_H

#include <QAbstractListModel>
#include <QSize>
#include <QBrush>
#include <QFont>
#include <QStringList>

//Класс списочной модели
class QListModel : public QAbstractListModel
{
    Q_OBJECT
public:
    explicit QListModel(QObject *parent = 0);
    //Возвращает кол-во элементов списка
    int rowCount(const QModelIndex & parent = QModelIndex()) const;

    //Возвращает значение элемента
    QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;

    //Сохраняет новое значение элемента
    bool setData(const QModelIndex & index, const QVariant & value, int role = Qt::EditRole);

    //Возвращает параметры редактируемости элемента
    Qt::ItemFlags flags(const QModelIndex & index) const;

    //Возвращает значение и параметры заголовков
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
private:
    //Список, в котором хранятся данные модели
    QList<int> list;
signals:
    
public slots:
    
};

#endif // QLISTMODEL_H
