#include "qsliderdeligate.h"
#include <QApplication>
#include <QStyleOptionProgressBar>

QSliderDeligate::QSliderDeligate(QObject *parent) :
    QStyledItemDelegate(parent)
{
}

QWidget *QSliderDeligate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    //Создание объекта редактора
    QSlider* editor = new QSlider(parent);
    editor->setOrientation(Qt::Horizontal);
    //для того, чтобы изображение элемента не просвечивало под редактором
    editor->setAutoFillBackground(true);

    return editor;
}

void QSliderDeligate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    //Приведение объекта редактора к нужному типу
    QSlider* slider = static_cast<QSlider*>(editor);
    //Отображение значения элемента в редакторе
    slider->setValue(index.data().toInt());
}

void QSliderDeligate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
    QSlider* slider = static_cast<QSlider*>(editor);
    //Сохранение значения отредактированного элемента в модели
    model->setData(index, slider->value());
}

void QSliderDeligate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    //Устанавливает положение и размер редактора (в данном случае соответствует размеру элемента)
    editor->setGeometry(option.rect);
}

void QSliderDeligate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    int value = index.data().toInt();

    //Создание и отображение пользовательского элемента отображения
    //Если этого не нужно, метод не надо переопределять
    QStyleOptionProgressBar progressBar;
    progressBar.minimum = 0;
    progressBar.maximum = 100;
    progressBar.rect = option.rect;
    progressBar.progress = value;
    progressBar.text = QString::number(value);
    progressBar.textVisible = true;

    QApplication::style()->drawControl(QStyle::CE_ProgressBar, &progressBar, painter);

}
